/*
 * Interrupt and TLB miss handling support.
 *
 * Copyright (C) 2015, 2016 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

.text
.extern tlb_handler
.extern interrupt_handler
.globl _tlb_entry
.globl _irq_entry
.globl _end_entries
.set noreorder

_tlb_entry:
	/* Save the status. */

	mfc0 $k0, $12 /* CP0_STATUS */
	nop
	sw $k0, -120($sp)

	/* Mask interrupts. */

	li $k1, 0xffff03ff
	and $k1, $k0, $k1
	mtc0 $k1, $12

	/* Save registers that the assembler wants to trash. */

        sw $t9, -100($sp)
        sw $gp, -104($sp)
        sw $ra, -112($sp)

	lui $gp, %hi(_GLOBAL_OFFSET_TABLE_)
	ori $gp, $gp, %lo(_GLOBAL_OFFSET_TABLE_)
	la $k0, tlb_handler
	jr $k0
	nop

_irq_entry:
	/* Save the status. */

	mfc0 $k0, $12 /* CP0_STATUS */
	nop
	sw $k0, -120($sp)

	/* Mask interrupts. */

	li $k1, 0xffff03ff
	and $k1, $k0, $k1
	mtc0 $k1, $12

	/* Save registers that the assembler wants to trash. */

        sw $t9, -100($sp)
        sw $gp, -104($sp)
        sw $ra, -112($sp)

	lui $gp, %hi(_GLOBAL_OFFSET_TABLE_)
	ori $gp, $gp, %lo(_GLOBAL_OFFSET_TABLE_)
	la $k0, interrupt_handler
	jr $k0
	nop

_end_entries:

.set reorder
